/*Copyright: Tim vor der Brck 1999

This software is released under the GNU General Public License Version 2

*/

#ifndef ccschachh
#define ccschachh
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <vgame/boardview.h>
#include <vgui/MessageBox.h>
#include <vgame/playersetupdialog.h>
#include <vbase/error.h>
#include "cchess.h" 
#include "csbrett.h"

const int numberoficons=7;

class Ccchess : public CGame, public CCaller
{
 public:
  Ccchess();
  ~Ccchess();
  friend ostream& operator<<(ostream& os,const Ccchess& cs);
  friend istream& operator>>(istream& is,Ccchess& cs);
  void drawboard(Display* display,GC gcbg,Pixmap& pixmap,int dx,int dy);
  CIcon* convvaluetoicon(int value);
  void create(csbrettklasse* board,CBoardview* boardview,Display* display,
       int dx,int dy,SharedData* sd,ResData* pappres,Widget statuswindow,
       Widget m_takeback,Widget m_lastown);

  
  void move(zug& z,bool remove);

  bool isinside(int x,int y)
  {
    if (x<1 || y<1 || x>xmax+1 || y>ymax+1) return false;
    return true;
  }

  void update(bool banalyse=true,bool bdraw=true);

  void newgame();

  void start_computermove(); 
  void do_computermove();
  void abort_computermove();
  void sendmessage(char c);
  void createstatusoutput();
  void updatestatuswindow();
  void setvalues(int lev0,int lev1); //,Boolean player1ishuman,Boolean player2ishuman);
  void oncancel();
  void takebackmove(bool upd=true);
  void drawcoords(Display* d,GC gc,Pixmap& pixmap,int fdx,int fdy,int dy);
  void drawstring(Display* d,GC gc,Pixmap& pixmap,
          char* str,int x,int y,int fdx,int fdy,int dy,XFontStruct* fs);
  void updatemenus();
  void psdhandleerror(int errnum); //psderrnum errnum);
  bool exists(int value,int f[xmax+1][ymax+1],int startx,int endx,int starty,int endy);
  bool valid(int f[xmax+1][ymax+1]);

  bool m_bsetuppos;
  bool m_bcomputermove;
  zctyp m_gamestate;
  int m_sp;
  int m_level[2];  
  FILE* m_input;
  zug m_lastmove;

 protected:
  
  void loadicons(char* red,char* black);
  CIcon m_icons[2][numberoficons];
  GC m_gcicons;
  Display* m_display;
  Window m_rootwin;
  int m_screennr;
  CBoardview* m_pboardview;
  csbrettklasse* m_pboard;
  Window m_win;
  FILE* m_output;
  SharedData* m_psd;  
  ResData* m_pappres;
  char m_statusoutput[100];
  Widget m_statuswindow;
  Widget m_takeback;
  Widget m_lastown;
};



#endif
